﻿package  {
	
	import flash.display.MovieClip;
	
	import flash.utils.Timer;							// Import the timer and the event for it
	import flash.events.TimerEvent;
	
	public class main extends MovieClip {
		
		// Digital 7 Font - by Chess-7
		// http://www.dafont.com/chess-7-chess-7.d1833
		
		var currentTime:Date;							// We dont need to instantiate this yet as it will get the time it was created
		var endDate:Date = new Date();					// Set the endDate to the time now
		
		var clockTimer = new Timer(1000);				// Make a new timer and set it to 1000 milliseconds (or 1 sec)
		
		public function main() {
			// ValidateThis.co.uk
			// Learn what getTime, setDate and setHours does here : http://livedocs.adobe.com/flash/9.0/main/wwhelp/wwhimpl/common/html/wwhelp.htm?context=LiveDocs_Parts&file=00001580.html
			
			// Figure out midnight today
			endDate.setDate(endDate.getDate() + 1);		// Set the date to tomorrow
			endDate.setHours(0,0,0,0);
			
			// Lets start the countdown
			clockTimer.addEventListener(TimerEvent.TIMER, timerTick);
			clockTimer.start();
			
			// Update the timer for the first time
			updateCountdown();
		}
		
		private function timerTick(e:TimerEvent):void {
			updateCountdown();
		}
		
		public function updateCountdown():void {
			var currentTime:Date = new Date();				// We now create a new Date and it will give us the current time
			
			// Get the current time difference
			var timeDifference:Number = endDate.getTime() - currentTime.getTime();			// Divide by 1000 because the results are in milliseconds
			
			// Calculate times
			var seconds:Number = Math.floor(timeDifference / 1000);
			var minutes:Number = Math.floor(seconds / 60);
			var hours:Number = Math.floor(minutes / 60);
			var days:Number = Math.floor(hours / 24); 
			
			// Set the remainder of the division vars above
			hours %= 24;
			minutes %= 60;
			seconds %= 60;
			
			
			// If everything has counted down to 0
			if (seconds < 0 || minutes < 0 || hours < 0){
				myCountdown.txtTimeLeft.text = "Time over";
				clockTimer.stop();						// Stop the clock from keep calling updateCountdown
			}else{
				// Create the strings for the clock so that we have a 0 infront of any number less than 10
				var tHours:String = (hours < 10) ? "0" + hours.toString() : hours.toString();
				var tMinutes:String = (minutes < 10) ? "0" + minutes.toString() : minutes.toString();
				var tSeconds:String = (seconds < 10) ? "0" + seconds.toString() : seconds.toString();
				
				// Set the text so we can read it
				myCountdown.txtTimeLeft.text = tHours + ":" + tMinutes + ":" + tSeconds;
			}
		}
	}
}
